All Classes Functions Variables Typedefs Enumerations Enumerator Pages
QwtPlotZoneItem Class Reference

A plot item, which displays a zone. More...

`#include <qwt_plot_zoneitem.h>`

Inheritance diagram for QwtPlotZoneItem:
[legend]

## Public Member Functions

| QwtPlotZoneItem ()
| Constructor. More...
virtual | ~QwtPlotZoneItem ()
| Destructor.
virtual int | rtti () const
void | setOrientation (Qt::Orientation)
| Set the orientation of the zone. More...
Qt::Orientation | orientation ()
void | setInterval (double min, double max)
void | setInterval (const QwtInterval &)
QwtInterval | interval () const
void | setPen (const QColor &, qreal width=0.0, Qt::PenStyle=Qt::SolidLine)
void | setPen (const QPen &)
| Assign a pen. More...
const QPen & | pen () const
void | setBrush (const QBrush &)
| Assign a brush. More...
const QBrush & | brush () const
virtual void | draw (QPainter *, const QwtScaleMap &, const QwtScaleMap &, const QRectF &) const
virtual QRectF | boundingRect () const
Public Member Functions inherited from QwtPlotItem
| QwtPlotItem (const QwtText &title=QwtText())
virtual | ~QwtPlotItem ()
| Destroy the QwtPlotItem.
void | attach (QwtPlot *plot)
| Attach the item to a plot. More...
void | detach ()
| This method detaches a QwtPlotItem from any QwtPlot it has been associated with. More...
QwtPlot * | plot () const
| Return attached plot.
void | setTitle (const QString &title)
void | setTitle (const QwtText &title)
const QwtText & | title () const
void | setItemAttribute (ItemAttribute, bool on=true)
bool | testItemAttribute (ItemAttribute) const
void | setItemInterest (ItemInterest, bool on=true)
bool | testItemInterest (ItemInterest) const
void | setRenderHint (RenderHint, bool on=true)
bool | testRenderHint (RenderHint) const
void | setRenderThreadCount (uint numThreads)
uint | renderThreadCount () const
void | setLegendIconSize (const QSize &)
QSize | legendIconSize () const
double | z () const
void | setZ (double z)
| Set the z value. More...
void | show ()
| Show the item.
void | hide ()
| Hide the item.
virtual void | setVisible (bool)
bool | isVisible () const
void | setAxes (int xAxis, int yAxis)
void | setXAxis (int axis)
int | xAxis () const
| Return xAxis.
void | setYAxis (int axis)
int | yAxis () const
| Return yAxis.
virtual void | itemChanged ()
virtual void | legendChanged ()
virtual void | getCanvasMarginHint (const QwtScaleMap &xMap, const QwtScaleMap &yMap, const QRectF &canvasSize, double &left, double &top, double &right, double &bottom) const
| Calculate a hint for the canvas margin. More...
virtual void | updateScaleDiv (const QwtScaleDiv &, const QwtScaleDiv &)
| Update the item to changes of the axes scale division. More...
virtual void | updateLegend (const QwtPlotItem *, const QList< QwtLegendData > &)
| Update the item to changes of the legend info. More...
QRectF | scaleRect (const QwtScaleMap &, const QwtScaleMap &) const
| Calculate the bounding scale rectangle of 2 maps. More...
QRectF | paintRect (const QwtScaleMap &, const QwtScaleMap &) const
| Calculate the bounding paint rectangle of 2 maps. More...
virtual QList< QwtLegendData > | legendData () const
| Return all information, that is needed to represent the item on the legend. More...
virtual QwtGraphic | legendIcon (int index, const QSizeF &) const

## Additional Inherited Members

Public Types inherited from QwtPlotItem
enum | RttiValues { Rtti_PlotItem = 0, Rtti_PlotGrid, Rtti_PlotScale, Rtti_PlotLegend, Rtti_PlotMarker, Rtti_PlotCurve, Rtti_PlotSpectroCurve, Rtti_PlotIntervalCurve, Rtti_PlotHistogram, Rtti_PlotSpectrogram, Rtti_PlotSVG, Rtti_PlotTradingCurve, Rtti_PlotBarChart, Rtti_PlotMultiBarChart, Rtti_PlotShape, Rtti_PlotTextLabel, Rtti_PlotZone, Rtti_PlotUserItem = 1000 }
| Runtime type information. More...
enum | ItemAttribute { Legend = 0x01, AutoScale = 0x02, Margins = 0x04 }
| Plot Item Attributes. More...
enum | ItemInterest { ScaleInterest = 0x01, LegendInterest = 0x02 }
| Plot Item Interests. More...
enum | RenderHint { RenderAntialiased = 0x1 }
| Render hints. More...
typedef QFlags< ItemAttribute > | ItemAttributes
| Plot Item Attributes.
typedef QFlags< ItemInterest > | ItemInterests
| Plot Item Interests.
typedef QFlags< RenderHint > | RenderHints
| Render hints.
Protected Member Functions inherited from QwtPlotItem
QwtGraphic | defaultIcon (const QBrush &, const QSizeF &) const
| Return a default icon from a brush. More...

## Detailed Description

A plot item, which displays a zone.

A horizontal zone highlights an interval of the y axis - a vertical zone an interval of the x axis - and is unbounded in the opposite direction. It is filled with a brush and its border lines are optionally displayed with a pen.

Note
  For displaying an area that is bounded for x and y coordinates use QwtPlotShapeItem

## Constructor & Destructor Documentation

QwtPlotZoneItem::QwtPlotZoneItem | ( |  | ) |

explicit

Constructor.

Initializes the zone with no pen and a semi transparent gray brush

Sets the following item attributes:

- QwtPlotItem::AutoScale: false
- QwtPlotItem::Legend: false

The z value is initialized by 5

See Also
  QwtPlotItem::setItemAttribute(), QwtPlotItem::setZ()

## Member Function Documentation

QRectF QwtPlotZoneItem::boundingRect | ( |  | ) | const

virtual

The bounding rectangle is build from the interval in one direction and something invalid for the opposite direction.

Returns
  An invalid rectangle with valid boundaries in one direction

Reimplemented from QwtPlotItem.

const QBrush & QwtPlotZoneItem::brush | ( |  | ) | const

Returns
  Brush used to fill the zone

See Also
  setPen(), brush()

void QwtPlotZoneItem::draw | ( | QPainter * | painter,
|  | const QwtScaleMap & | xMap,
|  | const QwtScaleMap & | yMap,
|  | const QRectF & | canvasRect
| ) |  | const

virtual

Draw the zone

Parameters

  painter | Painter
  xMap | x Scale Map
  yMap | y Scale Map
  canvasRect | Contents rectangle of the canvas in painter coordinates

Implements QwtPlotItem.

QwtInterval QwtPlotZoneItem::interval | ( |  | ) | const

Returns
  Zone interval

See Also
  setInterval(), orientation()

Qt::Orientation QwtPlotZoneItem::orientation | ( |  | ) |

Returns
  Orientation of the zone

See Also
  setOrientation()

const QPen & QwtPlotZoneItem::pen | ( |  | ) | const

Returns
  Pen used to draw the border lines

See Also
  setPen(), brush()

int QwtPlotZoneItem::rtti | ( |  | ) | const

virtual

Returns
  QwtPlotItem::Rtti_PlotZone

Reimplemented from QwtPlotItem.

void QwtPlotZoneItem::setBrush | ( | const QBrush & | brush | ) |

Assign a brush.

The brush is used to fill the zone

Parameters

  brush | Brush

See Also
  pen(), setBrush()

void QwtPlotZoneItem::setInterval | ( | double | min,
|  | double | max
| ) |  |

Set the interval of the zone

For a horizontal zone the interval is related to the y axis, for a vertical zone it is related to the x axis.

Parameters

  min | Minimum of the interval
  max | Maximum of the interval

See Also
  interval(), setOrientation()

void QwtPlotZoneItem::setInterval | ( | const QwtInterval & | interval | ) |

Set the interval of the zone

For a horizontal zone the interval is related to the y axis, for a vertical zone it is related to the x axis.

Parameters

  interval | Zone interval

See Also
  interval(), setOrientation()

void QwtPlotZoneItem::setOrientation | ( | Qt::Orientation | orientation | ) |

Set the orientation of the zone.

A horizontal zone highlights an interval of the y axis, a vertical zone of the x axis. It is unbounded in the opposite direction.

See Also
  orientation(), QwtPlotItem::setAxes()

void QwtPlotZoneItem::setPen | ( | const QColor & | color,
|  | qreal | width = `0.0`,
|  | Qt::PenStyle | style = `Qt::SolidLine`
| ) |  |

Build and assign a pen

In Qt5 the default pen width is 1.0 ( 0.0 in Qt4 ) what makes it non cosmetic ( see QPen::isCosmetic() ). This method has been introduced to hide this incompatibility.

Parameters

  color | Pen color
  width | Pen width
  style | Pen style

See Also
  pen(), brush()

void QwtPlotZoneItem::setPen | ( | const QPen & | pen | ) |

Assign a pen.

The pen is used to draw the border lines of the zone

Parameters

  pen | Pen

See Also
  pen(), setBrush()